package com.qmth.jkserver.model;

//import java.io.Serializable;
//import java.util.Date;
//
//import org.springframework.data.annotation.Id;
//import org.springframework.data.annotation.Transient;
//import org.springframework.data.mongodb.core.index.CompoundIndex;
//import org.springframework.data.mongodb.core.index.CompoundIndexes;
//import org.springframework.data.mongodb.core.index.Indexed;
//import org.springframework.data.mongodb.core.mapping.Document;
//import org.springframework.data.mongodb.core.mapping.Field;
//
//import com.qmth.jkserver.enums.ExamKwProgressType;
//
///**
// * 考务数据以及试卷下载统计
// * @author tianjun
// *
// */
//
//@Document(collection = "jk_exam_kw_progress")
//@CompoundIndexes({ @CompoundIndex(name = "exam_kw_progress_idx", unique=true, def = "{'exam_code':1,'place_code': 1, 'room_code': 1, 'type':1}") })
//public class ExamKwProgress implements Serializable {
//
//	/**
//	 *
//	 */
//	private static final long serialVersionUID = 7865645107596340752L;
//
//	@Id
//	private String id;
//
//	@Indexed
//	@Field("exam_code")
//	private String examCode;
//
//	@Field("place_code")
//	private String placeCode;
//
//	@Transient
//    //TODO 地方名称暂时不存入数据库
//	private String placeName;
//
//	@Field("room_code")
//	private String roomCode;
//
//	@Transient
//    //TODO 考场名称暂时不存入数据库
//	private String roomName;
//
//	@Field("type")
//	private ExamKwProgressType type;
//
//	@Field("download")
//	private boolean download;
//
//	//下载时间
//	@Field("time")
//	private Date time;
//
//	/**
//	 * @return the time
//	 */
//	public Date getTime() {
//		return time;
//	}
//
//	/**
//	 * @param time the time to set
//	 */
//	public void setTime(Date time) {
//		this.time = time;
//	}
//
//	/**
//	 * @return the type
//	 */
//	public ExamKwProgressType getType() {
//		return type;
//	}
//
//	/**
//	 * @param type the type to set
//	 */
//	public void setType(ExamKwProgressType type) {
//		this.type = type;
//	}
//
//	/**
//	 * @return the id
//	 */
//	public String getId() {
//		return id;
//	}
//
//	/**
//	 * @param id the id to set
//	 */
//	public void setId(String id) {
//		this.id = id;
//	}
//
//	/**
//	 * @return the examCode
//	 */
//	public String getExamCode() {
//		return examCode;
//	}
//
//	/**
//	 * @param examCode the examCode to set
//	 */
//	public void setExamCode(String examCode) {
//		this.examCode = examCode;
//	}
//
//	/**
//	 * @return the placeCode
//	 */
//	public String getPlaceCode() {
//		return placeCode;
//	}
//
//	/**
//	 * @param placeCode the placeCode to set
//	 */
//	public void setPlaceCode(String placeCode) {
//		this.placeCode = placeCode;
//	}
//
//	/**
//	 * @return the placeName
//	 */
//	public String getPlaceName() {
//		return placeName;
//	}
//
//	/**
//	 * @param placeName the placeName to set
//	 */
//	public void setPlaceName(String placeName) {
//		this.placeName = placeName;
//	}
//
//	/**
//	 * @return the roomCode
//	 */
//	public String getRoomCode() {
//		return roomCode;
//	}
//
//	/**
//	 * @param roomCode the roomCode to set
//	 */
//	public void setRoomCode(String roomCode) {
//		this.roomCode = roomCode;
//	}
//
//	/**
//	 * @return the roomName
//	 */
//	public String getRoomName() {
//		return roomName;
//	}
//
//	/**
//	 * @param roomName the roomName to set
//	 */
//	public void setRoomName(String roomName) {
//		this.roomName = roomName;
//	}
//
//	/**
//	 * @return the download
//	 */
//	public boolean isDownload() {
//		return download;
//	}
//
//	/**
//	 * @param download the download to set
//	 */
//	public void setDownload(boolean download) {
//		this.download = download;
//	}
//}

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.jkserver.enums.ExamKwProgressType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 考务数据以及试卷下载统计
 * </p>
 *
 * @author wangliang
 * @since 2023-03-01
 */
@ApiModel(value="JkExamKwProgress对象", description="考务数据以及试卷下载统计")
@TableName("jk_exam_kw_progress")
public class ExamKwProgress implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "考试编码")
    private String examCode;

    @ApiModelProperty(value = "地方编码")
    private String placeCode;

    @ApiModelProperty(value = "考场编码")
    private String roomCode;

    @ApiModelProperty(value = "类型，KW：下载考务考场数据，PAPER：下载试卷，UNCOILING：开卷")
    private ExamKwProgressType type;

    @ApiModelProperty(value = "是否下载，1：下载，0：未下载")
    private Boolean download;

    @ApiModelProperty(value = "下载时间")
    private Long time;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getExamCode() {
        return examCode;
    }

    public void setExamCode(String examCode) {
        this.examCode = examCode;
    }

    public String getPlaceCode() {
        return placeCode;
    }

    public void setPlaceCode(String placeCode) {
        this.placeCode = placeCode;
    }

    public String getRoomCode() {
        return roomCode;
    }

    public void setRoomCode(String roomCode) {
        this.roomCode = roomCode;
    }

    public ExamKwProgressType getType() {
        return type;
    }

    public void setType(ExamKwProgressType type) {
        this.type = type;
    }

    public Boolean getDownload() {
        return download;
    }

    public void setDownload(Boolean download) {
        this.download = download;
    }

    public Long getTime() {
        return time;
    }

    public void setTime(Long time) {
        this.time = time;
    }
}
